# Models

## The ErrorResponse object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"ErrorResponse":{"properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","items":{"$ref":"#/components/schemas/ErrorMessage"}}},"type":"object"},"ErrorMessage":{"properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}},"type":"object"}}}}
```

## The ErrorMessage object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"ErrorMessage":{"properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}},"type":"object"}}}}
```

## The ResourceType object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"ResourceType":{"description":"The type of the resource.","type":"string","enum":["collection","cluster","backup","user","database"]}}}}
```

## The ResourceId object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"ResourceId":{"type":"string","description":"The unique ID of the resource."}}}}
```

## The ResourceHref object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"ResourceHref":{"type":"string","description":"Absolute URL of the resource."}}}}
```

## The PostgresVersion object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"PostgresVersion":{"type":"string","description":"The PostgreSQL version of your cluster."}}}}
```

## The Instances object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"Instances":{"type":"integer","description":"The total number of instances in the cluster (one master and n-1\nstandbys).\n","minimum":1,"maximum":5}}}}
```

## The Cores object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"Cores":{"type":"integer","description":"The number of CPU cores per instance.","minimum":1}}}}
```

## The Ram object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"Ram":{"type":"integer","description":"The amount of memory per instance in megabytes. Has to be a multiple of 1024.","multipleOf":1024,"minimum":4096}}}}
```

## The StorageSize object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"StorageSize":{"type":"integer","description":"The amount of storage per instance in megabytes.","minimum":10240,"maximum":2097152}}}}
```

## The Location object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"Location":{"type":"string","description":"The physical location where the cluster will be created. This will be\nwhere all of your instances live. Property cannot be modified after\ndatacenter creation.\n"}}}}
```

## The DisplayName object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"DisplayName":{"type":"string","description":"The friendly name of your cluster."}}}}
```

## The DNSName object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"DNSName":{"type":"string","description":"The DNS name pointing to your cluster."}}}}
```

## The CreateClusterRequest object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"CreateClusterRequest":{"description":"Request payload with all data needed to create a new PostgreSQL cluster.\n","properties":{"metadata":{"$ref":"#/components/schemas/ClusterMetadata"},"properties":{"$ref":"#/components/schemas/CreateClusterProperties"}},"type":"object"},"ClusterMetadata":{"description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp."},"createdBy":{"type":"string"},"createdByUserId":{"type":"string"},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp."},"lastModifiedBy":{"type":"string"},"lastModifiedByUserId":{"type":"string"},"state":{"$ref":"#/components/schemas/State"}}},"State":{"description":"The current status reported back by the cluster.","type":"string","enum":["AVAILABLE","BUSY","DESTROYING","DEGRADED","FAILED","UNKNOWN"]},"CreateClusterProperties":{"description":"Properties with all data needed to create a new PostgreSQL cluster.\n","required":["postgresVersion","instances","cores","ram","storageSize","storageType","connections","location","displayName","credentials","synchronizationMode"],"properties":{"postgresVersion":{"$ref":"#/components/schemas/PostgresVersion"},"instances":{"$ref":"#/components/schemas/Instances"},"cores":{"$ref":"#/components/schemas/Cores"},"ram":{"$ref":"#/components/schemas/Ram"},"storageSize":{"$ref":"#/components/schemas/StorageSize"},"storageType":{"$ref":"#/components/schemas/StorageType"},"connections":{"type":"array","minItems":1,"maxItems":1,"items":{"$ref":"#/components/schemas/Connection"}},"location":{"$ref":"#/components/schemas/Location"},"backupLocation":{"$ref":"#/components/schemas/BackupLocation"},"displayName":{"$ref":"#/components/schemas/DisplayName"},"maintenanceWindow":{"$ref":"#/components/schemas/MaintenanceWindow"},"credentials":{"$ref":"#/components/schemas/DBUser"},"synchronizationMode":{"$ref":"#/components/schemas/CreateSynchronizationMode"},"fromBackup":{"$ref":"#/components/schemas/CreateRestoreRequest"},"connectionPooler":{"$ref":"#/components/schemas/ConnectionPooler"}},"type":"object"},"PostgresVersion":{"type":"string","description":"The PostgreSQL version of your cluster."},"Instances":{"type":"integer","description":"The total number of instances in the cluster (one master and n-1\nstandbys).\n","minimum":1,"maximum":5},"Cores":{"type":"integer","description":"The number of CPU cores per instance.","minimum":1},"Ram":{"type":"integer","description":"The amount of memory per instance in megabytes. Has to be a multiple of 1024.","multipleOf":1024,"minimum":4096},"StorageSize":{"type":"integer","description":"The amount of storage per instance in megabytes.","minimum":10240,"maximum":2097152},"StorageType":{"description":"The storage type used in your cluster. (Value \"SSD\" is deprecated. Use the equivalent \"SSD Premium\" instead)","type":"string","enum":["HDD","SSD","SSD Standard","SSD Premium"]},"Connection":{"description":"Details about the network connection for your cluster.","properties":{"datacenterId":{"description":"The datacenter to connect your cluster to.","type":"string"},"lanId":{"description":"The numeric LAN ID to connect your cluster to.","type":"string"},"cidr":{"type":"string","description":"The IP and subnet for your cluster.\nNote the following unavailable IP ranges:\n10.233.64.0/18\n10.233.0.0/18\n10.233.114.0/24\n"}},"required":["datacenterId","lanId","cidr"],"type":"object"},"Location":{"type":"string","description":"The physical location where the cluster will be created. This will be\nwhere all of your instances live. Property cannot be modified after\ndatacenter creation.\n"},"BackupLocation":{"type":"string","description":"The S3 location where the backups will be stored."},"DisplayName":{"type":"string","description":"The friendly name of your cluster."},"MaintenanceWindow":{"description":"A weekly 4 hour-long window, during which maintenance might occur.\n","properties":{"time":{"type":"string","description":"Start of the maintenance window in UTC time."},"dayOfTheWeek":{"$ref":"#/components/schemas/DayOfTheWeek"}},"required":["time","dayOfTheWeek"],"type":"object"},"DayOfTheWeek":{"description":"The name of the week day.","type":"string","enum":["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"]},"DBUser":{"description":"Credentials for the database user to be created.","properties":{"username":{"type":"string","description":"The username for the initial PostgreSQL user. Some system usernames\nare restricted (e.g. \"postgres\", \"admin\", \"standby\").\n"},"password":{"type":"string","minLength":10}},"required":["username","password"],"type":"object"},"CreateSynchronizationMode":{"description":"Represents the supported replication modes when creating a cluster.\nThe SYNCHRONOUS mode is deprecated and cannot be used in create requests.\nIt may still appear on existing clusters via the SynchronizationMode response schema.\nYou may update your cluster to one of the supported modes yourself.\nElse, it will eventually be migrated to one of the supported modes.\n","type":"string","enum":["ASYNCHRONOUS","STRICTLY_SYNCHRONOUS"]},"CreateRestoreRequest":{"description":"The restore request.","properties":{"backupId":{"type":"string","description":"The unique ID of the backup you want to restore."},"recoveryTargetTime":{"type":"string","format":"date-time","description":"If this value is supplied as ISO 8601 timestamp, the backup will be\nreplayed up until the given timestamp. If empty, the backup will be\napplied completely.\n"}},"required":["backupId"],"type":"object"},"ConnectionPooler":{"description":"Configuration options for the connection pooler","properties":{"enabled":{"type":"boolean"},"poolMode":{"$ref":"#/components/schemas/PoolMode"}}},"PoolMode":{"description":"Represents different modes of connection pooling for the connection pooler.\n","type":"string","enum":["transaction","session"]}}}}
```

## The CreateClusterProperties object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"CreateClusterProperties":{"description":"Properties with all data needed to create a new PostgreSQL cluster.\n","required":["postgresVersion","instances","cores","ram","storageSize","storageType","connections","location","displayName","credentials","synchronizationMode"],"properties":{"postgresVersion":{"$ref":"#/components/schemas/PostgresVersion"},"instances":{"$ref":"#/components/schemas/Instances"},"cores":{"$ref":"#/components/schemas/Cores"},"ram":{"$ref":"#/components/schemas/Ram"},"storageSize":{"$ref":"#/components/schemas/StorageSize"},"storageType":{"$ref":"#/components/schemas/StorageType"},"connections":{"type":"array","minItems":1,"maxItems":1,"items":{"$ref":"#/components/schemas/Connection"}},"location":{"$ref":"#/components/schemas/Location"},"backupLocation":{"$ref":"#/components/schemas/BackupLocation"},"displayName":{"$ref":"#/components/schemas/DisplayName"},"maintenanceWindow":{"$ref":"#/components/schemas/MaintenanceWindow"},"credentials":{"$ref":"#/components/schemas/DBUser"},"synchronizationMode":{"$ref":"#/components/schemas/CreateSynchronizationMode"},"fromBackup":{"$ref":"#/components/schemas/CreateRestoreRequest"},"connectionPooler":{"$ref":"#/components/schemas/ConnectionPooler"}},"type":"object"},"PostgresVersion":{"type":"string","description":"The PostgreSQL version of your cluster."},"Instances":{"type":"integer","description":"The total number of instances in the cluster (one master and n-1\nstandbys).\n","minimum":1,"maximum":5},"Cores":{"type":"integer","description":"The number of CPU cores per instance.","minimum":1},"Ram":{"type":"integer","description":"The amount of memory per instance in megabytes. Has to be a multiple of 1024.","multipleOf":1024,"minimum":4096},"StorageSize":{"type":"integer","description":"The amount of storage per instance in megabytes.","minimum":10240,"maximum":2097152},"StorageType":{"description":"The storage type used in your cluster. (Value \"SSD\" is deprecated. Use the equivalent \"SSD Premium\" instead)","type":"string","enum":["HDD","SSD","SSD Standard","SSD Premium"]},"Connection":{"description":"Details about the network connection for your cluster.","properties":{"datacenterId":{"description":"The datacenter to connect your cluster to.","type":"string"},"lanId":{"description":"The numeric LAN ID to connect your cluster to.","type":"string"},"cidr":{"type":"string","description":"The IP and subnet for your cluster.\nNote the following unavailable IP ranges:\n10.233.64.0/18\n10.233.0.0/18\n10.233.114.0/24\n"}},"required":["datacenterId","lanId","cidr"],"type":"object"},"Location":{"type":"string","description":"The physical location where the cluster will be created. This will be\nwhere all of your instances live. Property cannot be modified after\ndatacenter creation.\n"},"BackupLocation":{"type":"string","description":"The S3 location where the backups will be stored."},"DisplayName":{"type":"string","description":"The friendly name of your cluster."},"MaintenanceWindow":{"description":"A weekly 4 hour-long window, during which maintenance might occur.\n","properties":{"time":{"type":"string","description":"Start of the maintenance window in UTC time."},"dayOfTheWeek":{"$ref":"#/components/schemas/DayOfTheWeek"}},"required":["time","dayOfTheWeek"],"type":"object"},"DayOfTheWeek":{"description":"The name of the week day.","type":"string","enum":["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"]},"DBUser":{"description":"Credentials for the database user to be created.","properties":{"username":{"type":"string","description":"The username for the initial PostgreSQL user. Some system usernames\nare restricted (e.g. \"postgres\", \"admin\", \"standby\").\n"},"password":{"type":"string","minLength":10}},"required":["username","password"],"type":"object"},"CreateSynchronizationMode":{"description":"Represents the supported replication modes when creating a cluster.\nThe SYNCHRONOUS mode is deprecated and cannot be used in create requests.\nIt may still appear on existing clusters via the SynchronizationMode response schema.\nYou may update your cluster to one of the supported modes yourself.\nElse, it will eventually be migrated to one of the supported modes.\n","type":"string","enum":["ASYNCHRONOUS","STRICTLY_SYNCHRONOUS"]},"CreateRestoreRequest":{"description":"The restore request.","properties":{"backupId":{"type":"string","description":"The unique ID of the backup you want to restore."},"recoveryTargetTime":{"type":"string","format":"date-time","description":"If this value is supplied as ISO 8601 timestamp, the backup will be\nreplayed up until the given timestamp. If empty, the backup will be\napplied completely.\n"}},"required":["backupId"],"type":"object"},"ConnectionPooler":{"description":"Configuration options for the connection pooler","properties":{"enabled":{"type":"boolean"},"poolMode":{"$ref":"#/components/schemas/PoolMode"}}},"PoolMode":{"description":"Represents different modes of connection pooling for the connection pooler.\n","type":"string","enum":["transaction","session"]}}}}
```

## The PatchClusterRequest object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"PatchClusterRequest":{"description":"Request payload to change a cluster.","properties":{"metadata":{"$ref":"#/components/schemas/ClusterMetadata"},"properties":{"$ref":"#/components/schemas/PatchClusterProperties"}},"type":"object"},"ClusterMetadata":{"description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp."},"createdBy":{"type":"string"},"createdByUserId":{"type":"string"},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp."},"lastModifiedBy":{"type":"string"},"lastModifiedByUserId":{"type":"string"},"state":{"$ref":"#/components/schemas/State"}}},"State":{"description":"The current status reported back by the cluster.","type":"string","enum":["AVAILABLE","BUSY","DESTROYING","DEGRADED","FAILED","UNKNOWN"]},"PatchClusterProperties":{"description":"Properties of the payload to change a cluster.","properties":{"cores":{"$ref":"#/components/schemas/Cores"},"ram":{"$ref":"#/components/schemas/Ram"},"storageSize":{"$ref":"#/components/schemas/StorageSize"},"connections":{"type":"array","minItems":0,"maxItems":1,"items":{"$ref":"#/components/schemas/Connection"}},"displayName":{"$ref":"#/components/schemas/DisplayName"},"maintenanceWindow":{"$ref":"#/components/schemas/MaintenanceWindow"},"postgresVersion":{"$ref":"#/components/schemas/PostgresVersion"},"instances":{"$ref":"#/components/schemas/Instances"},"connectionPooler":{"$ref":"#/components/schemas/ConnectionPooler"},"synchronizationMode":{"$ref":"#/components/schemas/SynchronizationMode"}},"type":"object"},"Cores":{"type":"integer","description":"The number of CPU cores per instance.","minimum":1},"Ram":{"type":"integer","description":"The amount of memory per instance in megabytes. Has to be a multiple of 1024.","multipleOf":1024,"minimum":4096},"StorageSize":{"type":"integer","description":"The amount of storage per instance in megabytes.","minimum":10240,"maximum":2097152},"Connection":{"description":"Details about the network connection for your cluster.","properties":{"datacenterId":{"description":"The datacenter to connect your cluster to.","type":"string"},"lanId":{"description":"The numeric LAN ID to connect your cluster to.","type":"string"},"cidr":{"type":"string","description":"The IP and subnet for your cluster.\nNote the following unavailable IP ranges:\n10.233.64.0/18\n10.233.0.0/18\n10.233.114.0/24\n"}},"required":["datacenterId","lanId","cidr"],"type":"object"},"DisplayName":{"type":"string","description":"The friendly name of your cluster."},"MaintenanceWindow":{"description":"A weekly 4 hour-long window, during which maintenance might occur.\n","properties":{"time":{"type":"string","description":"Start of the maintenance window in UTC time."},"dayOfTheWeek":{"$ref":"#/components/schemas/DayOfTheWeek"}},"required":["time","dayOfTheWeek"],"type":"object"},"DayOfTheWeek":{"description":"The name of the week day.","type":"string","enum":["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"]},"PostgresVersion":{"type":"string","description":"The PostgreSQL version of your cluster."},"Instances":{"type":"integer","description":"The total number of instances in the cluster (one master and n-1\nstandbys).\n","minimum":1,"maximum":5},"ConnectionPooler":{"description":"Configuration options for the connection pooler","properties":{"enabled":{"type":"boolean"},"poolMode":{"$ref":"#/components/schemas/PoolMode"}}},"PoolMode":{"description":"Represents different modes of connection pooling for the connection pooler.\n","type":"string","enum":["transaction","session"]},"SynchronizationMode":{"description":"Represents different modes of replication.\nBe aware that the SYNCHRONOUS mode is deprecated and will be removed in future versions.\nExisting clusters will eventually be migrated to one of the supported modes.\n","type":"string","enum":["ASYNCHRONOUS","SYNCHRONOUS","STRICTLY_SYNCHRONOUS"]}}}}
```

## The PatchClusterProperties object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"PatchClusterProperties":{"description":"Properties of the payload to change a cluster.","properties":{"cores":{"$ref":"#/components/schemas/Cores"},"ram":{"$ref":"#/components/schemas/Ram"},"storageSize":{"$ref":"#/components/schemas/StorageSize"},"connections":{"type":"array","minItems":0,"maxItems":1,"items":{"$ref":"#/components/schemas/Connection"}},"displayName":{"$ref":"#/components/schemas/DisplayName"},"maintenanceWindow":{"$ref":"#/components/schemas/MaintenanceWindow"},"postgresVersion":{"$ref":"#/components/schemas/PostgresVersion"},"instances":{"$ref":"#/components/schemas/Instances"},"connectionPooler":{"$ref":"#/components/schemas/ConnectionPooler"},"synchronizationMode":{"$ref":"#/components/schemas/SynchronizationMode"}},"type":"object"},"Cores":{"type":"integer","description":"The number of CPU cores per instance.","minimum":1},"Ram":{"type":"integer","description":"The amount of memory per instance in megabytes. Has to be a multiple of 1024.","multipleOf":1024,"minimum":4096},"StorageSize":{"type":"integer","description":"The amount of storage per instance in megabytes.","minimum":10240,"maximum":2097152},"Connection":{"description":"Details about the network connection for your cluster.","properties":{"datacenterId":{"description":"The datacenter to connect your cluster to.","type":"string"},"lanId":{"description":"The numeric LAN ID to connect your cluster to.","type":"string"},"cidr":{"type":"string","description":"The IP and subnet for your cluster.\nNote the following unavailable IP ranges:\n10.233.64.0/18\n10.233.0.0/18\n10.233.114.0/24\n"}},"required":["datacenterId","lanId","cidr"],"type":"object"},"DisplayName":{"type":"string","description":"The friendly name of your cluster."},"MaintenanceWindow":{"description":"A weekly 4 hour-long window, during which maintenance might occur.\n","properties":{"time":{"type":"string","description":"Start of the maintenance window in UTC time."},"dayOfTheWeek":{"$ref":"#/components/schemas/DayOfTheWeek"}},"required":["time","dayOfTheWeek"],"type":"object"},"DayOfTheWeek":{"description":"The name of the week day.","type":"string","enum":["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"]},"PostgresVersion":{"type":"string","description":"The PostgreSQL version of your cluster."},"Instances":{"type":"integer","description":"The total number of instances in the cluster (one master and n-1\nstandbys).\n","minimum":1,"maximum":5},"ConnectionPooler":{"description":"Configuration options for the connection pooler","properties":{"enabled":{"type":"boolean"},"poolMode":{"$ref":"#/components/schemas/PoolMode"}}},"PoolMode":{"description":"Represents different modes of connection pooling for the connection pooler.\n","type":"string","enum":["transaction","session"]},"SynchronizationMode":{"description":"Represents different modes of replication.\nBe aware that the SYNCHRONOUS mode is deprecated and will be removed in future versions.\nExisting clusters will eventually be migrated to one of the supported modes.\n","type":"string","enum":["ASYNCHRONOUS","SYNCHRONOUS","STRICTLY_SYNCHRONOUS"]}}}}
```

## The CreateRestoreRequest object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"CreateRestoreRequest":{"description":"The restore request.","properties":{"backupId":{"type":"string","description":"The unique ID of the backup you want to restore."},"recoveryTargetTime":{"type":"string","format":"date-time","description":"If this value is supplied as ISO 8601 timestamp, the backup will be\nreplayed up until the given timestamp. If empty, the backup will be\napplied completely.\n"}},"required":["backupId"],"type":"object"}}}}
```

## The DBUser object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"DBUser":{"description":"Credentials for the database user to be created.","properties":{"username":{"type":"string","description":"The username for the initial PostgreSQL user. Some system usernames\nare restricted (e.g. \"postgres\", \"admin\", \"standby\").\n"},"password":{"type":"string","minLength":10}},"required":["username","password"],"type":"object"}}}}
```

## The Connection object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"Connection":{"description":"Details about the network connection for your cluster.","properties":{"datacenterId":{"description":"The datacenter to connect your cluster to.","type":"string"},"lanId":{"description":"The numeric LAN ID to connect your cluster to.","type":"string"},"cidr":{"type":"string","description":"The IP and subnet for your cluster.\nNote the following unavailable IP ranges:\n10.233.64.0/18\n10.233.0.0/18\n10.233.114.0/24\n"}},"required":["datacenterId","lanId","cidr"],"type":"object"}}}}
```

## The ClusterMetadata object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"ClusterMetadata":{"description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp."},"createdBy":{"type":"string"},"createdByUserId":{"type":"string"},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp."},"lastModifiedBy":{"type":"string"},"lastModifiedByUserId":{"type":"string"},"state":{"$ref":"#/components/schemas/State"}}},"State":{"description":"The current status reported back by the cluster.","type":"string","enum":["AVAILABLE","BUSY","DESTROYING","DEGRADED","FAILED","UNKNOWN"]}}}}
```

## The State object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"State":{"description":"The current status reported back by the cluster.","type":"string","enum":["AVAILABLE","BUSY","DESTROYING","DEGRADED","FAILED","UNKNOWN"]}}}}
```

## The BackupMetadata object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"BackupMetadata":{"description":"Metadata of the backup resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp."},"state":{"$ref":"#/components/schemas/State"}},"type":"object"},"State":{"description":"The current status reported back by the cluster.","type":"string","enum":["AVAILABLE","BUSY","DESTROYING","DEGRADED","FAILED","UNKNOWN"]}}}}
```

## The ClusterResponse object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"ClusterResponse":{"description":"A database cluster.","properties":{"type":{"allOf":[{"$ref":"#/components/schemas/ResourceType"}]},"id":{"$ref":"#/components/schemas/ResourceId"},"metadata":{"$ref":"#/components/schemas/ClusterMetadata"},"properties":{"$ref":"#/components/schemas/ClusterProperties"}},"type":"object"},"ResourceType":{"description":"The type of the resource.","type":"string","enum":["collection","cluster","backup","user","database"]},"ResourceId":{"type":"string","description":"The unique ID of the resource."},"ClusterMetadata":{"description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp."},"createdBy":{"type":"string"},"createdByUserId":{"type":"string"},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp."},"lastModifiedBy":{"type":"string"},"lastModifiedByUserId":{"type":"string"},"state":{"$ref":"#/components/schemas/State"}}},"State":{"description":"The current status reported back by the cluster.","type":"string","enum":["AVAILABLE","BUSY","DESTROYING","DEGRADED","FAILED","UNKNOWN"]},"ClusterProperties":{"description":"Properties of a database cluster.","properties":{"displayName":{"$ref":"#/components/schemas/DisplayName"},"postgresVersion":{"$ref":"#/components/schemas/PostgresVersion"},"location":{"$ref":"#/components/schemas/Location"},"dnsName":{"$ref":"#/components/schemas/DNSName"},"backupLocation":{"$ref":"#/components/schemas/BackupLocation"},"instances":{"$ref":"#/components/schemas/Instances"},"ram":{"$ref":"#/components/schemas/Ram"},"cores":{"$ref":"#/components/schemas/Cores"},"storageSize":{"$ref":"#/components/schemas/StorageSize"},"storageType":{"$ref":"#/components/schemas/StorageType"},"connections":{"type":"array","minItems":1,"maxItems":1,"items":{"$ref":"#/components/schemas/Connection"}},"maintenanceWindow":{"$ref":"#/components/schemas/MaintenanceWindow"},"synchronizationMode":{"$ref":"#/components/schemas/SynchronizationMode"},"connectionPooler":{"$ref":"#/components/schemas/ConnectionPooler"}},"type":"object"},"DisplayName":{"type":"string","description":"The friendly name of your cluster."},"PostgresVersion":{"type":"string","description":"The PostgreSQL version of your cluster."},"Location":{"type":"string","description":"The physical location where the cluster will be created. This will be\nwhere all of your instances live. Property cannot be modified after\ndatacenter creation.\n"},"DNSName":{"type":"string","description":"The DNS name pointing to your cluster."},"BackupLocation":{"type":"string","description":"The S3 location where the backups will be stored."},"Instances":{"type":"integer","description":"The total number of instances in the cluster (one master and n-1\nstandbys).\n","minimum":1,"maximum":5},"Ram":{"type":"integer","description":"The amount of memory per instance in megabytes. Has to be a multiple of 1024.","multipleOf":1024,"minimum":4096},"Cores":{"type":"integer","description":"The number of CPU cores per instance.","minimum":1},"StorageSize":{"type":"integer","description":"The amount of storage per instance in megabytes.","minimum":10240,"maximum":2097152},"StorageType":{"description":"The storage type used in your cluster. (Value \"SSD\" is deprecated. Use the equivalent \"SSD Premium\" instead)","type":"string","enum":["HDD","SSD","SSD Standard","SSD Premium"]},"Connection":{"description":"Details about the network connection for your cluster.","properties":{"datacenterId":{"description":"The datacenter to connect your cluster to.","type":"string"},"lanId":{"description":"The numeric LAN ID to connect your cluster to.","type":"string"},"cidr":{"type":"string","description":"The IP and subnet for your cluster.\nNote the following unavailable IP ranges:\n10.233.64.0/18\n10.233.0.0/18\n10.233.114.0/24\n"}},"required":["datacenterId","lanId","cidr"],"type":"object"},"MaintenanceWindow":{"description":"A weekly 4 hour-long window, during which maintenance might occur.\n","properties":{"time":{"type":"string","description":"Start of the maintenance window in UTC time."},"dayOfTheWeek":{"$ref":"#/components/schemas/DayOfTheWeek"}},"required":["time","dayOfTheWeek"],"type":"object"},"DayOfTheWeek":{"description":"The name of the week day.","type":"string","enum":["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"]},"SynchronizationMode":{"description":"Represents different modes of replication.\nBe aware that the SYNCHRONOUS mode is deprecated and will be removed in future versions.\nExisting clusters will eventually be migrated to one of the supported modes.\n","type":"string","enum":["ASYNCHRONOUS","SYNCHRONOUS","STRICTLY_SYNCHRONOUS"]},"ConnectionPooler":{"description":"Configuration options for the connection pooler","properties":{"enabled":{"type":"boolean"},"poolMode":{"$ref":"#/components/schemas/PoolMode"}}},"PoolMode":{"description":"Represents different modes of connection pooling for the connection pooler.\n","type":"string","enum":["transaction","session"]}}}}
```

## The ClusterProperties object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"ClusterProperties":{"description":"Properties of a database cluster.","properties":{"displayName":{"$ref":"#/components/schemas/DisplayName"},"postgresVersion":{"$ref":"#/components/schemas/PostgresVersion"},"location":{"$ref":"#/components/schemas/Location"},"dnsName":{"$ref":"#/components/schemas/DNSName"},"backupLocation":{"$ref":"#/components/schemas/BackupLocation"},"instances":{"$ref":"#/components/schemas/Instances"},"ram":{"$ref":"#/components/schemas/Ram"},"cores":{"$ref":"#/components/schemas/Cores"},"storageSize":{"$ref":"#/components/schemas/StorageSize"},"storageType":{"$ref":"#/components/schemas/StorageType"},"connections":{"type":"array","minItems":1,"maxItems":1,"items":{"$ref":"#/components/schemas/Connection"}},"maintenanceWindow":{"$ref":"#/components/schemas/MaintenanceWindow"},"synchronizationMode":{"$ref":"#/components/schemas/SynchronizationMode"},"connectionPooler":{"$ref":"#/components/schemas/ConnectionPooler"}},"type":"object"},"DisplayName":{"type":"string","description":"The friendly name of your cluster."},"PostgresVersion":{"type":"string","description":"The PostgreSQL version of your cluster."},"Location":{"type":"string","description":"The physical location where the cluster will be created. This will be\nwhere all of your instances live. Property cannot be modified after\ndatacenter creation.\n"},"DNSName":{"type":"string","description":"The DNS name pointing to your cluster."},"BackupLocation":{"type":"string","description":"The S3 location where the backups will be stored."},"Instances":{"type":"integer","description":"The total number of instances in the cluster (one master and n-1\nstandbys).\n","minimum":1,"maximum":5},"Ram":{"type":"integer","description":"The amount of memory per instance in megabytes. Has to be a multiple of 1024.","multipleOf":1024,"minimum":4096},"Cores":{"type":"integer","description":"The number of CPU cores per instance.","minimum":1},"StorageSize":{"type":"integer","description":"The amount of storage per instance in megabytes.","minimum":10240,"maximum":2097152},"StorageType":{"description":"The storage type used in your cluster. (Value \"SSD\" is deprecated. Use the equivalent \"SSD Premium\" instead)","type":"string","enum":["HDD","SSD","SSD Standard","SSD Premium"]},"Connection":{"description":"Details about the network connection for your cluster.","properties":{"datacenterId":{"description":"The datacenter to connect your cluster to.","type":"string"},"lanId":{"description":"The numeric LAN ID to connect your cluster to.","type":"string"},"cidr":{"type":"string","description":"The IP and subnet for your cluster.\nNote the following unavailable IP ranges:\n10.233.64.0/18\n10.233.0.0/18\n10.233.114.0/24\n"}},"required":["datacenterId","lanId","cidr"],"type":"object"},"MaintenanceWindow":{"description":"A weekly 4 hour-long window, during which maintenance might occur.\n","properties":{"time":{"type":"string","description":"Start of the maintenance window in UTC time."},"dayOfTheWeek":{"$ref":"#/components/schemas/DayOfTheWeek"}},"required":["time","dayOfTheWeek"],"type":"object"},"DayOfTheWeek":{"description":"The name of the week day.","type":"string","enum":["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"]},"SynchronizationMode":{"description":"Represents different modes of replication.\nBe aware that the SYNCHRONOUS mode is deprecated and will be removed in future versions.\nExisting clusters will eventually be migrated to one of the supported modes.\n","type":"string","enum":["ASYNCHRONOUS","SYNCHRONOUS","STRICTLY_SYNCHRONOUS"]},"ConnectionPooler":{"description":"Configuration options for the connection pooler","properties":{"enabled":{"type":"boolean"},"poolMode":{"$ref":"#/components/schemas/PoolMode"}}},"PoolMode":{"description":"Represents different modes of connection pooling for the connection pooler.\n","type":"string","enum":["transaction","session"]}}}}
```

## The BackupResponse object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"BackupResponse":{"description":"A database backup.","properties":{"type":{"allOf":[{"$ref":"#/components/schemas/ResourceType"}]},"id":{"$ref":"#/components/schemas/ResourceId"},"metadata":{"$ref":"#/components/schemas/BackupMetadata"},"properties":{"$ref":"#/components/schemas/ClusterBackup"}},"type":"object"},"ResourceType":{"description":"The type of the resource.","type":"string","enum":["collection","cluster","backup","user","database"]},"ResourceId":{"type":"string","description":"The unique ID of the resource."},"BackupMetadata":{"description":"Metadata of the backup resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp."},"state":{"$ref":"#/components/schemas/State"}},"type":"object"},"State":{"description":"The current status reported back by the cluster.","type":"string","enum":["AVAILABLE","BUSY","DESTROYING","DEGRADED","FAILED","UNKNOWN"]},"ClusterBackup":{"description":"A backup object.","properties":{"id":{"$ref":"#/components/schemas/ResourceId"},"clusterId":{"type":"string","description":"The unique ID of the cluster."},"version":{"type":"string","description":"The PostgreSQL version this backup was created from."},"isActive":{"type":"boolean","description":"Whether a cluster currently backs up data to this backup."},"earliestRecoveryTargetTime":{"type":"string","format":"date-time","description":"The oldest available timestamp to which you can restore."},"size":{"type":"integer","description":"Size of all base backups including the wal size in MB."},"location":{"$ref":"#/components/schemas/BackupLocation"}},"type":"object"},"BackupLocation":{"type":"string","description":"The S3 location where the backups will be stored."}}}}
```

## The ClusterBackup object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"ClusterBackup":{"description":"A backup object.","properties":{"id":{"$ref":"#/components/schemas/ResourceId"},"clusterId":{"type":"string","description":"The unique ID of the cluster."},"version":{"type":"string","description":"The PostgreSQL version this backup was created from."},"isActive":{"type":"boolean","description":"Whether a cluster currently backs up data to this backup."},"earliestRecoveryTargetTime":{"type":"string","format":"date-time","description":"The oldest available timestamp to which you can restore."},"size":{"type":"integer","description":"Size of all base backups including the wal size in MB."},"location":{"$ref":"#/components/schemas/BackupLocation"}},"type":"object"},"ResourceId":{"type":"string","description":"The unique ID of the resource."},"BackupLocation":{"type":"string","description":"The S3 location where the backups will be stored."}}}}
```

## The BackupLocation object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"BackupLocation":{"type":"string","description":"The S3 location where the backups will be stored."}}}}
```

## The MaintenanceWindow object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"MaintenanceWindow":{"description":"A weekly 4 hour-long window, during which maintenance might occur.\n","properties":{"time":{"type":"string","description":"Start of the maintenance window in UTC time."},"dayOfTheWeek":{"$ref":"#/components/schemas/DayOfTheWeek"}},"required":["time","dayOfTheWeek"],"type":"object"},"DayOfTheWeek":{"description":"The name of the week day.","type":"string","enum":["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"]}}}}
```

## The DayOfTheWeek object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"DayOfTheWeek":{"description":"The name of the week day.","type":"string","enum":["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"]}}}}
```

## The APIVersion object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"APIVersion":{"properties":{"name":{"type":"string"},"swaggerUrl":{"type":"string"}},"type":"object"}}}}
```

## The StorageType object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"StorageType":{"description":"The storage type used in your cluster. (Value \"SSD\" is deprecated. Use the equivalent \"SSD Premium\" instead)","type":"string","enum":["HDD","SSD","SSD Standard","SSD Premium"]}}}}
```

## The DeprecatedPagination object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"DeprecatedPagination":{"description":"Pagination information in list responses. DEPRECATED because of misspelled _links attribute.","type":"object","properties":{"offset":{"$ref":"#/components/schemas/PaginationOffset"},"limit":{"$ref":"#/components/schemas/PaginationLimit"},"links":{"$ref":"#/components/schemas/PaginationLinks"}}},"PaginationOffset":{"description":"The offset specified in the request (if none was specified, the default\noffset is 0).\n","type":"integer","minimum":0,"default":0},"PaginationLimit":{"description":"The limit specified in the request (if none was specified, the default\nlimit is 100).\n","type":"integer","minimum":0,"default":100,"maximum":1000},"PaginationLinks":{"description":"URLs to navigate the different pages.\n","type":"object","properties":{"prev":{"description":"URL (with offset and limit parameters) of the previous page; only\npresent if offset is greater than 0.\n","type":"string","format":"uri","readOnly":true},"self":{"description":"URL (with offset and limit parameters) of the current page.\n","type":"string","format":"uri","readOnly":true},"next":{"description":"URL (with offset and limit parameters) of the next page; only\npresent if offset + limit is less than the total number of elements.\n","type":"string","format":"uri","readOnly":true}}}}}}
```

## The Pagination object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"Pagination":{"description":"Pagination information in list responses.","type":"object","properties":{"offset":{"$ref":"#/components/schemas/PaginationOffset"},"limit":{"$ref":"#/components/schemas/PaginationLimit"},"_links":{"$ref":"#/components/schemas/PaginationLinks"}}},"PaginationOffset":{"description":"The offset specified in the request (if none was specified, the default\noffset is 0).\n","type":"integer","minimum":0,"default":0},"PaginationLimit":{"description":"The limit specified in the request (if none was specified, the default\nlimit is 100).\n","type":"integer","minimum":0,"default":100,"maximum":1000},"PaginationLinks":{"description":"URLs to navigate the different pages.\n","type":"object","properties":{"prev":{"description":"URL (with offset and limit parameters) of the previous page; only\npresent if offset is greater than 0.\n","type":"string","format":"uri","readOnly":true},"self":{"description":"URL (with offset and limit parameters) of the current page.\n","type":"string","format":"uri","readOnly":true},"next":{"description":"URL (with offset and limit parameters) of the next page; only\npresent if offset + limit is less than the total number of elements.\n","type":"string","format":"uri","readOnly":true}}}}}}
```

## The PaginationOffset object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"PaginationOffset":{"description":"The offset specified in the request (if none was specified, the default\noffset is 0).\n","type":"integer","minimum":0,"default":0}}}}
```

## The PaginationLimit object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"PaginationLimit":{"description":"The limit specified in the request (if none was specified, the default\nlimit is 100).\n","type":"integer","minimum":0,"default":100,"maximum":1000}}}}
```

## The PaginationLinks object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"PaginationLinks":{"description":"URLs to navigate the different pages.\n","type":"object","properties":{"prev":{"description":"URL (with offset and limit parameters) of the previous page; only\npresent if offset is greater than 0.\n","type":"string","format":"uri","readOnly":true},"self":{"description":"URL (with offset and limit parameters) of the current page.\n","type":"string","format":"uri","readOnly":true},"next":{"description":"URL (with offset and limit parameters) of the next page; only\npresent if offset + limit is less than the total number of elements.\n","type":"string","format":"uri","readOnly":true}}}}}}
```

## The ClusterList object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"ClusterList":{"description":"List of clusters.","allOf":[{"type":"object","properties":{"type":{"$ref":"#/components/schemas/ResourceType"},"id":{"$ref":"#/components/schemas/ResourceId"},"items":{"type":"array","items":{"$ref":"#/components/schemas/ClusterResponse"}}}},{"$ref":"#/components/schemas/DeprecatedPagination"}],"type":"object"},"ResourceType":{"description":"The type of the resource.","type":"string","enum":["collection","cluster","backup","user","database"]},"ResourceId":{"type":"string","description":"The unique ID of the resource."},"ClusterResponse":{"description":"A database cluster.","properties":{"type":{"allOf":[{"$ref":"#/components/schemas/ResourceType"}]},"id":{"$ref":"#/components/schemas/ResourceId"},"metadata":{"$ref":"#/components/schemas/ClusterMetadata"},"properties":{"$ref":"#/components/schemas/ClusterProperties"}},"type":"object"},"ClusterMetadata":{"description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp."},"createdBy":{"type":"string"},"createdByUserId":{"type":"string"},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp."},"lastModifiedBy":{"type":"string"},"lastModifiedByUserId":{"type":"string"},"state":{"$ref":"#/components/schemas/State"}}},"State":{"description":"The current status reported back by the cluster.","type":"string","enum":["AVAILABLE","BUSY","DESTROYING","DEGRADED","FAILED","UNKNOWN"]},"ClusterProperties":{"description":"Properties of a database cluster.","properties":{"displayName":{"$ref":"#/components/schemas/DisplayName"},"postgresVersion":{"$ref":"#/components/schemas/PostgresVersion"},"location":{"$ref":"#/components/schemas/Location"},"dnsName":{"$ref":"#/components/schemas/DNSName"},"backupLocation":{"$ref":"#/components/schemas/BackupLocation"},"instances":{"$ref":"#/components/schemas/Instances"},"ram":{"$ref":"#/components/schemas/Ram"},"cores":{"$ref":"#/components/schemas/Cores"},"storageSize":{"$ref":"#/components/schemas/StorageSize"},"storageType":{"$ref":"#/components/schemas/StorageType"},"connections":{"type":"array","minItems":1,"maxItems":1,"items":{"$ref":"#/components/schemas/Connection"}},"maintenanceWindow":{"$ref":"#/components/schemas/MaintenanceWindow"},"synchronizationMode":{"$ref":"#/components/schemas/SynchronizationMode"},"connectionPooler":{"$ref":"#/components/schemas/ConnectionPooler"}},"type":"object"},"DisplayName":{"type":"string","description":"The friendly name of your cluster."},"PostgresVersion":{"type":"string","description":"The PostgreSQL version of your cluster."},"Location":{"type":"string","description":"The physical location where the cluster will be created. This will be\nwhere all of your instances live. Property cannot be modified after\ndatacenter creation.\n"},"DNSName":{"type":"string","description":"The DNS name pointing to your cluster."},"BackupLocation":{"type":"string","description":"The S3 location where the backups will be stored."},"Instances":{"type":"integer","description":"The total number of instances in the cluster (one master and n-1\nstandbys).\n","minimum":1,"maximum":5},"Ram":{"type":"integer","description":"The amount of memory per instance in megabytes. Has to be a multiple of 1024.","multipleOf":1024,"minimum":4096},"Cores":{"type":"integer","description":"The number of CPU cores per instance.","minimum":1},"StorageSize":{"type":"integer","description":"The amount of storage per instance in megabytes.","minimum":10240,"maximum":2097152},"StorageType":{"description":"The storage type used in your cluster. (Value \"SSD\" is deprecated. Use the equivalent \"SSD Premium\" instead)","type":"string","enum":["HDD","SSD","SSD Standard","SSD Premium"]},"Connection":{"description":"Details about the network connection for your cluster.","properties":{"datacenterId":{"description":"The datacenter to connect your cluster to.","type":"string"},"lanId":{"description":"The numeric LAN ID to connect your cluster to.","type":"string"},"cidr":{"type":"string","description":"The IP and subnet for your cluster.\nNote the following unavailable IP ranges:\n10.233.64.0/18\n10.233.0.0/18\n10.233.114.0/24\n"}},"required":["datacenterId","lanId","cidr"],"type":"object"},"MaintenanceWindow":{"description":"A weekly 4 hour-long window, during which maintenance might occur.\n","properties":{"time":{"type":"string","description":"Start of the maintenance window in UTC time."},"dayOfTheWeek":{"$ref":"#/components/schemas/DayOfTheWeek"}},"required":["time","dayOfTheWeek"],"type":"object"},"DayOfTheWeek":{"description":"The name of the week day.","type":"string","enum":["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"]},"SynchronizationMode":{"description":"Represents different modes of replication.\nBe aware that the SYNCHRONOUS mode is deprecated and will be removed in future versions.\nExisting clusters will eventually be migrated to one of the supported modes.\n","type":"string","enum":["ASYNCHRONOUS","SYNCHRONOUS","STRICTLY_SYNCHRONOUS"]},"ConnectionPooler":{"description":"Configuration options for the connection pooler","properties":{"enabled":{"type":"boolean"},"poolMode":{"$ref":"#/components/schemas/PoolMode"}}},"PoolMode":{"description":"Represents different modes of connection pooling for the connection pooler.\n","type":"string","enum":["transaction","session"]},"DeprecatedPagination":{"description":"Pagination information in list responses. DEPRECATED because of misspelled _links attribute.","type":"object","properties":{"offset":{"$ref":"#/components/schemas/PaginationOffset"},"limit":{"$ref":"#/components/schemas/PaginationLimit"},"links":{"$ref":"#/components/schemas/PaginationLinks"}}},"PaginationOffset":{"description":"The offset specified in the request (if none was specified, the default\noffset is 0).\n","type":"integer","minimum":0,"default":0},"PaginationLimit":{"description":"The limit specified in the request (if none was specified, the default\nlimit is 100).\n","type":"integer","minimum":0,"default":100,"maximum":1000},"PaginationLinks":{"description":"URLs to navigate the different pages.\n","type":"object","properties":{"prev":{"description":"URL (with offset and limit parameters) of the previous page; only\npresent if offset is greater than 0.\n","type":"string","format":"uri","readOnly":true},"self":{"description":"URL (with offset and limit parameters) of the current page.\n","type":"string","format":"uri","readOnly":true},"next":{"description":"URL (with offset and limit parameters) of the next page; only\npresent if offset + limit is less than the total number of elements.\n","type":"string","format":"uri","readOnly":true}}}}}}
```

## The ClusterBackupList object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"ClusterBackupList":{"description":"List of backups.","allOf":[{"type":"object","properties":{"type":{"$ref":"#/components/schemas/ResourceType"},"id":{"$ref":"#/components/schemas/ResourceId"},"items":{"type":"array","items":{"$ref":"#/components/schemas/BackupResponse"}}}},{"$ref":"#/components/schemas/DeprecatedPagination"}]},"ResourceType":{"description":"The type of the resource.","type":"string","enum":["collection","cluster","backup","user","database"]},"ResourceId":{"type":"string","description":"The unique ID of the resource."},"BackupResponse":{"description":"A database backup.","properties":{"type":{"allOf":[{"$ref":"#/components/schemas/ResourceType"}]},"id":{"$ref":"#/components/schemas/ResourceId"},"metadata":{"$ref":"#/components/schemas/BackupMetadata"},"properties":{"$ref":"#/components/schemas/ClusterBackup"}},"type":"object"},"BackupMetadata":{"description":"Metadata of the backup resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp."},"state":{"$ref":"#/components/schemas/State"}},"type":"object"},"State":{"description":"The current status reported back by the cluster.","type":"string","enum":["AVAILABLE","BUSY","DESTROYING","DEGRADED","FAILED","UNKNOWN"]},"ClusterBackup":{"description":"A backup object.","properties":{"id":{"$ref":"#/components/schemas/ResourceId"},"clusterId":{"type":"string","description":"The unique ID of the cluster."},"version":{"type":"string","description":"The PostgreSQL version this backup was created from."},"isActive":{"type":"boolean","description":"Whether a cluster currently backs up data to this backup."},"earliestRecoveryTargetTime":{"type":"string","format":"date-time","description":"The oldest available timestamp to which you can restore."},"size":{"type":"integer","description":"Size of all base backups including the wal size in MB."},"location":{"$ref":"#/components/schemas/BackupLocation"}},"type":"object"},"BackupLocation":{"type":"string","description":"The S3 location where the backups will be stored."},"DeprecatedPagination":{"description":"Pagination information in list responses. DEPRECATED because of misspelled _links attribute.","type":"object","properties":{"offset":{"$ref":"#/components/schemas/PaginationOffset"},"limit":{"$ref":"#/components/schemas/PaginationLimit"},"links":{"$ref":"#/components/schemas/PaginationLinks"}}},"PaginationOffset":{"description":"The offset specified in the request (if none was specified, the default\noffset is 0).\n","type":"integer","minimum":0,"default":0},"PaginationLimit":{"description":"The limit specified in the request (if none was specified, the default\nlimit is 100).\n","type":"integer","minimum":0,"default":100,"maximum":1000},"PaginationLinks":{"description":"URLs to navigate the different pages.\n","type":"object","properties":{"prev":{"description":"URL (with offset and limit parameters) of the previous page; only\npresent if offset is greater than 0.\n","type":"string","format":"uri","readOnly":true},"self":{"description":"URL (with offset and limit parameters) of the current page.\n","type":"string","format":"uri","readOnly":true},"next":{"description":"URL (with offset and limit parameters) of the next page; only\npresent if offset + limit is less than the total number of elements.\n","type":"string","format":"uri","readOnly":true}}}}}}
```

## The PostgresVersionList object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"PostgresVersionList":{"description":"List of PostgreSQL versions.","properties":{"data":{"type":"array","items":{"properties":{"name":{"type":"string"}},"type":"object"}}},"type":"object"}}}}
```

## The ClusterLogs object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"ClusterLogs":{"description":"The logs of the PostgreSQL cluster.","properties":{"instances":{"type":"array","items":{"properties":{"name":{"description":"The name of the PostgreSQL instance.","type":"string"},"messages":{"type":"array","items":{"type":"object","properties":{"time":{"type":"string","format":"date-time"},"message":{"type":"string"}}}}},"type":"object"}}},"type":"object"}}}}
```

## The CreateSynchronizationMode object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"CreateSynchronizationMode":{"description":"Represents the supported replication modes when creating a cluster.\nThe SYNCHRONOUS mode is deprecated and cannot be used in create requests.\nIt may still appear on existing clusters via the SynchronizationMode response schema.\nYou may update your cluster to one of the supported modes yourself.\nElse, it will eventually be migrated to one of the supported modes.\n","type":"string","enum":["ASYNCHRONOUS","STRICTLY_SYNCHRONOUS"]}}}}
```

## The SynchronizationMode object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"SynchronizationMode":{"description":"Represents different modes of replication.\nBe aware that the SYNCHRONOUS mode is deprecated and will be removed in future versions.\nExisting clusters will eventually be migrated to one of the supported modes.\n","type":"string","enum":["ASYNCHRONOUS","SYNCHRONOUS","STRICTLY_SYNCHRONOUS"]}}}}
```

## The ConnectionPooler object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"ConnectionPooler":{"description":"Configuration options for the connection pooler","properties":{"enabled":{"type":"boolean"},"poolMode":{"$ref":"#/components/schemas/PoolMode"}}},"PoolMode":{"description":"Represents different modes of connection pooling for the connection pooler.\n","type":"string","enum":["transaction","session"]}}}}
```

## The PoolMode object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"PoolMode":{"description":"Represents different modes of connection pooling for the connection pooler.\n","type":"string","enum":["transaction","session"]}}}}
```

## The UserList object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"UserList":{"type":"object","allOf":[{"$ref":"#/components/schemas/Pagination"},{"$ref":"#/components/schemas/Resource"},{"$ref":"#/components/schemas/UserItems"}]},"Pagination":{"description":"Pagination information in list responses.","type":"object","properties":{"offset":{"$ref":"#/components/schemas/PaginationOffset"},"limit":{"$ref":"#/components/schemas/PaginationLimit"},"_links":{"$ref":"#/components/schemas/PaginationLinks"}}},"PaginationOffset":{"description":"The offset specified in the request (if none was specified, the default\noffset is 0).\n","type":"integer","minimum":0,"default":0},"PaginationLimit":{"description":"The limit specified in the request (if none was specified, the default\nlimit is 100).\n","type":"integer","minimum":0,"default":100,"maximum":1000},"PaginationLinks":{"description":"URLs to navigate the different pages.\n","type":"object","properties":{"prev":{"description":"URL (with offset and limit parameters) of the previous page; only\npresent if offset is greater than 0.\n","type":"string","format":"uri","readOnly":true},"self":{"description":"URL (with offset and limit parameters) of the current page.\n","type":"string","format":"uri","readOnly":true},"next":{"description":"URL (with offset and limit parameters) of the next page; only\npresent if offset + limit is less than the total number of elements.\n","type":"string","format":"uri","readOnly":true}}},"Resource":{"type":"object","required":["type","id","href"],"properties":{"type":{"$ref":"#/components/schemas/ResourceType"},"id":{"$ref":"#/components/schemas/ResourceId"},"href":{"$ref":"#/components/schemas/ResourceHref"}}},"ResourceType":{"description":"The type of the resource.","type":"string","enum":["collection","cluster","backup","user","database"]},"ResourceId":{"type":"string","description":"The unique ID of the resource."},"ResourceHref":{"type":"string","description":"Absolute URL of the resource."},"UserItems":{"type":"object","required":["items"],"properties":{"items":{"type":"array","items":{"$ref":"#/components/schemas/UserResource"}}}},"UserResource":{"type":"object","allOf":[{"$ref":"#/components/schemas/Resource"},{"$ref":"#/components/schemas/ResourceMetadata"},{"$ref":"#/components/schemas/User"}]},"ResourceMetadata":{"type":"object","properties":{"metadata":{"$ref":"#/components/schemas/Metadata"}}},"Metadata":{"type":"object","properties":{"createdBy":{"$ref":"#/components/schemas/UserIdentityURN"},"createdByUserId":{"$ref":"#/components/schemas/UserIdentityUUID"},"createdDate":{"$ref":"#/components/schemas/Timestamp"},"lastModifiedBy":{"$ref":"#/components/schemas/UserIdentityURN"},"lastModifiedByUserId":{"$ref":"#/components/schemas/UserIdentityUUID"},"lastModifiedDate":{"$ref":"#/components/schemas/Timestamp"},"resourceURN":{"$ref":"#/components/schemas/ResourceURN"}}},"UserIdentityURN":{"type":"string","description":"The URN of an IAM user."},"UserIdentityUUID":{"type":"string","format":"uuid","description":"The ID of an IAM user."},"Timestamp":{"type":"string","format":"date-time","description":"An ISO 8601 timestamp."},"ResourceURN":{"type":"string","description":"The URN of the resource."},"User":{"type":"object","required":["properties"],"properties":{"properties":{"$ref":"#/components/schemas/UserProperties"}}},"UserProperties":{"type":"object","required":["username"],"properties":{"username":{"$ref":"#/components/schemas/Username"},"password":{"$ref":"#/components/schemas/Password"},"system":{"$ref":"#/components/schemas/IsSystemUser"}}},"Username":{"type":"string","description":"The username of a given user.","minLength":1,"maxLength":63},"Password":{"type":"string","description":"The password of a given user.","writeOnly":true,"minLength":10,"maxLength":63},"IsSystemUser":{"type":"boolean","description":"Describes whether this user is a system user or not. A system user cannot be updated or deleted.","readOnly":true}}}}
```

## The UserItems object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"UserItems":{"type":"object","required":["items"],"properties":{"items":{"type":"array","items":{"$ref":"#/components/schemas/UserResource"}}}},"UserResource":{"type":"object","allOf":[{"$ref":"#/components/schemas/Resource"},{"$ref":"#/components/schemas/ResourceMetadata"},{"$ref":"#/components/schemas/User"}]},"Resource":{"type":"object","required":["type","id","href"],"properties":{"type":{"$ref":"#/components/schemas/ResourceType"},"id":{"$ref":"#/components/schemas/ResourceId"},"href":{"$ref":"#/components/schemas/ResourceHref"}}},"ResourceType":{"description":"The type of the resource.","type":"string","enum":["collection","cluster","backup","user","database"]},"ResourceId":{"type":"string","description":"The unique ID of the resource."},"ResourceHref":{"type":"string","description":"Absolute URL of the resource."},"ResourceMetadata":{"type":"object","properties":{"metadata":{"$ref":"#/components/schemas/Metadata"}}},"Metadata":{"type":"object","properties":{"createdBy":{"$ref":"#/components/schemas/UserIdentityURN"},"createdByUserId":{"$ref":"#/components/schemas/UserIdentityUUID"},"createdDate":{"$ref":"#/components/schemas/Timestamp"},"lastModifiedBy":{"$ref":"#/components/schemas/UserIdentityURN"},"lastModifiedByUserId":{"$ref":"#/components/schemas/UserIdentityUUID"},"lastModifiedDate":{"$ref":"#/components/schemas/Timestamp"},"resourceURN":{"$ref":"#/components/schemas/ResourceURN"}}},"UserIdentityURN":{"type":"string","description":"The URN of an IAM user."},"UserIdentityUUID":{"type":"string","format":"uuid","description":"The ID of an IAM user."},"Timestamp":{"type":"string","format":"date-time","description":"An ISO 8601 timestamp."},"ResourceURN":{"type":"string","description":"The URN of the resource."},"User":{"type":"object","required":["properties"],"properties":{"properties":{"$ref":"#/components/schemas/UserProperties"}}},"UserProperties":{"type":"object","required":["username"],"properties":{"username":{"$ref":"#/components/schemas/Username"},"password":{"$ref":"#/components/schemas/Password"},"system":{"$ref":"#/components/schemas/IsSystemUser"}}},"Username":{"type":"string","description":"The username of a given user.","minLength":1,"maxLength":63},"Password":{"type":"string","description":"The password of a given user.","writeOnly":true,"minLength":10,"maxLength":63},"IsSystemUser":{"type":"boolean","description":"Describes whether this user is a system user or not. A system user cannot be updated or deleted.","readOnly":true}}}}
```

## The UserResource object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"UserResource":{"type":"object","allOf":[{"$ref":"#/components/schemas/Resource"},{"$ref":"#/components/schemas/ResourceMetadata"},{"$ref":"#/components/schemas/User"}]},"Resource":{"type":"object","required":["type","id","href"],"properties":{"type":{"$ref":"#/components/schemas/ResourceType"},"id":{"$ref":"#/components/schemas/ResourceId"},"href":{"$ref":"#/components/schemas/ResourceHref"}}},"ResourceType":{"description":"The type of the resource.","type":"string","enum":["collection","cluster","backup","user","database"]},"ResourceId":{"type":"string","description":"The unique ID of the resource."},"ResourceHref":{"type":"string","description":"Absolute URL of the resource."},"ResourceMetadata":{"type":"object","properties":{"metadata":{"$ref":"#/components/schemas/Metadata"}}},"Metadata":{"type":"object","properties":{"createdBy":{"$ref":"#/components/schemas/UserIdentityURN"},"createdByUserId":{"$ref":"#/components/schemas/UserIdentityUUID"},"createdDate":{"$ref":"#/components/schemas/Timestamp"},"lastModifiedBy":{"$ref":"#/components/schemas/UserIdentityURN"},"lastModifiedByUserId":{"$ref":"#/components/schemas/UserIdentityUUID"},"lastModifiedDate":{"$ref":"#/components/schemas/Timestamp"},"resourceURN":{"$ref":"#/components/schemas/ResourceURN"}}},"UserIdentityURN":{"type":"string","description":"The URN of an IAM user."},"UserIdentityUUID":{"type":"string","format":"uuid","description":"The ID of an IAM user."},"Timestamp":{"type":"string","format":"date-time","description":"An ISO 8601 timestamp."},"ResourceURN":{"type":"string","description":"The URN of the resource."},"User":{"type":"object","required":["properties"],"properties":{"properties":{"$ref":"#/components/schemas/UserProperties"}}},"UserProperties":{"type":"object","required":["username"],"properties":{"username":{"$ref":"#/components/schemas/Username"},"password":{"$ref":"#/components/schemas/Password"},"system":{"$ref":"#/components/schemas/IsSystemUser"}}},"Username":{"type":"string","description":"The username of a given user.","minLength":1,"maxLength":63},"Password":{"type":"string","description":"The password of a given user.","writeOnly":true,"minLength":10,"maxLength":63},"IsSystemUser":{"type":"boolean","description":"Describes whether this user is a system user or not. A system user cannot be updated or deleted.","readOnly":true}}}}
```

## The User object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"User":{"type":"object","required":["properties"],"properties":{"properties":{"$ref":"#/components/schemas/UserProperties"}}},"UserProperties":{"type":"object","required":["username"],"properties":{"username":{"$ref":"#/components/schemas/Username"},"password":{"$ref":"#/components/schemas/Password"},"system":{"$ref":"#/components/schemas/IsSystemUser"}}},"Username":{"type":"string","description":"The username of a given user.","minLength":1,"maxLength":63},"Password":{"type":"string","description":"The password of a given user.","writeOnly":true,"minLength":10,"maxLength":63},"IsSystemUser":{"type":"boolean","description":"Describes whether this user is a system user or not. A system user cannot be updated or deleted.","readOnly":true}}}}
```

## The PatchUserProperties object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"PatchUserProperties":{"type":"object","properties":{"password":{"$ref":"#/components/schemas/Password"}}},"Password":{"type":"string","description":"The password of a given user.","writeOnly":true,"minLength":10,"maxLength":63}}}}
```

## The UserProperties object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"UserProperties":{"type":"object","required":["username"],"properties":{"username":{"$ref":"#/components/schemas/Username"},"password":{"$ref":"#/components/schemas/Password"},"system":{"$ref":"#/components/schemas/IsSystemUser"}}},"Username":{"type":"string","description":"The username of a given user.","minLength":1,"maxLength":63},"Password":{"type":"string","description":"The password of a given user.","writeOnly":true,"minLength":10,"maxLength":63},"IsSystemUser":{"type":"boolean","description":"Describes whether this user is a system user or not. A system user cannot be updated or deleted.","readOnly":true}}}}
```

## The Username object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"Username":{"type":"string","description":"The username of a given user.","minLength":1,"maxLength":63}}}}
```

## The Password object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"Password":{"type":"string","description":"The password of a given user.","writeOnly":true,"minLength":10,"maxLength":63}}}}
```

## The IsSystemUser object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"IsSystemUser":{"type":"boolean","description":"Describes whether this user is a system user or not. A system user cannot be updated or deleted.","readOnly":true}}}}
```

## The DatabaseList object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"DatabaseList":{"type":"object","allOf":[{"$ref":"#/components/schemas/Pagination"},{"$ref":"#/components/schemas/Resource"},{"$ref":"#/components/schemas/DatabaseItems"}]},"Pagination":{"description":"Pagination information in list responses.","type":"object","properties":{"offset":{"$ref":"#/components/schemas/PaginationOffset"},"limit":{"$ref":"#/components/schemas/PaginationLimit"},"_links":{"$ref":"#/components/schemas/PaginationLinks"}}},"PaginationOffset":{"description":"The offset specified in the request (if none was specified, the default\noffset is 0).\n","type":"integer","minimum":0,"default":0},"PaginationLimit":{"description":"The limit specified in the request (if none was specified, the default\nlimit is 100).\n","type":"integer","minimum":0,"default":100,"maximum":1000},"PaginationLinks":{"description":"URLs to navigate the different pages.\n","type":"object","properties":{"prev":{"description":"URL (with offset and limit parameters) of the previous page; only\npresent if offset is greater than 0.\n","type":"string","format":"uri","readOnly":true},"self":{"description":"URL (with offset and limit parameters) of the current page.\n","type":"string","format":"uri","readOnly":true},"next":{"description":"URL (with offset and limit parameters) of the next page; only\npresent if offset + limit is less than the total number of elements.\n","type":"string","format":"uri","readOnly":true}}},"Resource":{"type":"object","required":["type","id","href"],"properties":{"type":{"$ref":"#/components/schemas/ResourceType"},"id":{"$ref":"#/components/schemas/ResourceId"},"href":{"$ref":"#/components/schemas/ResourceHref"}}},"ResourceType":{"description":"The type of the resource.","type":"string","enum":["collection","cluster","backup","user","database"]},"ResourceId":{"type":"string","description":"The unique ID of the resource."},"ResourceHref":{"type":"string","description":"Absolute URL of the resource."},"DatabaseItems":{"type":"object","required":["items"],"properties":{"items":{"type":"array","items":{"$ref":"#/components/schemas/DatabaseResource"}}}},"DatabaseResource":{"type":"object","allOf":[{"$ref":"#/components/schemas/Resource"},{"$ref":"#/components/schemas/ResourceMetadata"},{"$ref":"#/components/schemas/Database"}]},"ResourceMetadata":{"type":"object","properties":{"metadata":{"$ref":"#/components/schemas/Metadata"}}},"Metadata":{"type":"object","properties":{"createdBy":{"$ref":"#/components/schemas/UserIdentityURN"},"createdByUserId":{"$ref":"#/components/schemas/UserIdentityUUID"},"createdDate":{"$ref":"#/components/schemas/Timestamp"},"lastModifiedBy":{"$ref":"#/components/schemas/UserIdentityURN"},"lastModifiedByUserId":{"$ref":"#/components/schemas/UserIdentityUUID"},"lastModifiedDate":{"$ref":"#/components/schemas/Timestamp"},"resourceURN":{"$ref":"#/components/schemas/ResourceURN"}}},"UserIdentityURN":{"type":"string","description":"The URN of an IAM user."},"UserIdentityUUID":{"type":"string","format":"uuid","description":"The ID of an IAM user."},"Timestamp":{"type":"string","format":"date-time","description":"An ISO 8601 timestamp."},"ResourceURN":{"type":"string","description":"The URN of the resource."},"Database":{"type":"object","required":["properties"],"properties":{"properties":{"$ref":"#/components/schemas/DatabaseProperties"}}},"DatabaseProperties":{"type":"object","required":["name","owner"],"properties":{"name":{"$ref":"#/components/schemas/Databasename"},"owner":{"$ref":"#/components/schemas/Databaseowner"}}},"Databasename":{"type":"string","description":"The databasename of a given database.","minLength":1,"maxLength":63},"Databaseowner":{"type":"string","description":"The name of the role owning a given database.","minLength":1,"maxLength":63}}}}
```

## The DatabaseItems object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"DatabaseItems":{"type":"object","required":["items"],"properties":{"items":{"type":"array","items":{"$ref":"#/components/schemas/DatabaseResource"}}}},"DatabaseResource":{"type":"object","allOf":[{"$ref":"#/components/schemas/Resource"},{"$ref":"#/components/schemas/ResourceMetadata"},{"$ref":"#/components/schemas/Database"}]},"Resource":{"type":"object","required":["type","id","href"],"properties":{"type":{"$ref":"#/components/schemas/ResourceType"},"id":{"$ref":"#/components/schemas/ResourceId"},"href":{"$ref":"#/components/schemas/ResourceHref"}}},"ResourceType":{"description":"The type of the resource.","type":"string","enum":["collection","cluster","backup","user","database"]},"ResourceId":{"type":"string","description":"The unique ID of the resource."},"ResourceHref":{"type":"string","description":"Absolute URL of the resource."},"ResourceMetadata":{"type":"object","properties":{"metadata":{"$ref":"#/components/schemas/Metadata"}}},"Metadata":{"type":"object","properties":{"createdBy":{"$ref":"#/components/schemas/UserIdentityURN"},"createdByUserId":{"$ref":"#/components/schemas/UserIdentityUUID"},"createdDate":{"$ref":"#/components/schemas/Timestamp"},"lastModifiedBy":{"$ref":"#/components/schemas/UserIdentityURN"},"lastModifiedByUserId":{"$ref":"#/components/schemas/UserIdentityUUID"},"lastModifiedDate":{"$ref":"#/components/schemas/Timestamp"},"resourceURN":{"$ref":"#/components/schemas/ResourceURN"}}},"UserIdentityURN":{"type":"string","description":"The URN of an IAM user."},"UserIdentityUUID":{"type":"string","format":"uuid","description":"The ID of an IAM user."},"Timestamp":{"type":"string","format":"date-time","description":"An ISO 8601 timestamp."},"ResourceURN":{"type":"string","description":"The URN of the resource."},"Database":{"type":"object","required":["properties"],"properties":{"properties":{"$ref":"#/components/schemas/DatabaseProperties"}}},"DatabaseProperties":{"type":"object","required":["name","owner"],"properties":{"name":{"$ref":"#/components/schemas/Databasename"},"owner":{"$ref":"#/components/schemas/Databaseowner"}}},"Databasename":{"type":"string","description":"The databasename of a given database.","minLength":1,"maxLength":63},"Databaseowner":{"type":"string","description":"The name of the role owning a given database.","minLength":1,"maxLength":63}}}}
```

## The DatabaseResource object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"DatabaseResource":{"type":"object","allOf":[{"$ref":"#/components/schemas/Resource"},{"$ref":"#/components/schemas/ResourceMetadata"},{"$ref":"#/components/schemas/Database"}]},"Resource":{"type":"object","required":["type","id","href"],"properties":{"type":{"$ref":"#/components/schemas/ResourceType"},"id":{"$ref":"#/components/schemas/ResourceId"},"href":{"$ref":"#/components/schemas/ResourceHref"}}},"ResourceType":{"description":"The type of the resource.","type":"string","enum":["collection","cluster","backup","user","database"]},"ResourceId":{"type":"string","description":"The unique ID of the resource."},"ResourceHref":{"type":"string","description":"Absolute URL of the resource."},"ResourceMetadata":{"type":"object","properties":{"metadata":{"$ref":"#/components/schemas/Metadata"}}},"Metadata":{"type":"object","properties":{"createdBy":{"$ref":"#/components/schemas/UserIdentityURN"},"createdByUserId":{"$ref":"#/components/schemas/UserIdentityUUID"},"createdDate":{"$ref":"#/components/schemas/Timestamp"},"lastModifiedBy":{"$ref":"#/components/schemas/UserIdentityURN"},"lastModifiedByUserId":{"$ref":"#/components/schemas/UserIdentityUUID"},"lastModifiedDate":{"$ref":"#/components/schemas/Timestamp"},"resourceURN":{"$ref":"#/components/schemas/ResourceURN"}}},"UserIdentityURN":{"type":"string","description":"The URN of an IAM user."},"UserIdentityUUID":{"type":"string","format":"uuid","description":"The ID of an IAM user."},"Timestamp":{"type":"string","format":"date-time","description":"An ISO 8601 timestamp."},"ResourceURN":{"type":"string","description":"The URN of the resource."},"Database":{"type":"object","required":["properties"],"properties":{"properties":{"$ref":"#/components/schemas/DatabaseProperties"}}},"DatabaseProperties":{"type":"object","required":["name","owner"],"properties":{"name":{"$ref":"#/components/schemas/Databasename"},"owner":{"$ref":"#/components/schemas/Databaseowner"}}},"Databasename":{"type":"string","description":"The databasename of a given database.","minLength":1,"maxLength":63},"Databaseowner":{"type":"string","description":"The name of the role owning a given database.","minLength":1,"maxLength":63}}}}
```

## The Database object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"Database":{"type":"object","required":["properties"],"properties":{"properties":{"$ref":"#/components/schemas/DatabaseProperties"}}},"DatabaseProperties":{"type":"object","required":["name","owner"],"properties":{"name":{"$ref":"#/components/schemas/Databasename"},"owner":{"$ref":"#/components/schemas/Databaseowner"}}},"Databasename":{"type":"string","description":"The databasename of a given database.","minLength":1,"maxLength":63},"Databaseowner":{"type":"string","description":"The name of the role owning a given database.","minLength":1,"maxLength":63}}}}
```

## The DatabaseProperties object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"DatabaseProperties":{"type":"object","required":["name","owner"],"properties":{"name":{"$ref":"#/components/schemas/Databasename"},"owner":{"$ref":"#/components/schemas/Databaseowner"}}},"Databasename":{"type":"string","description":"The databasename of a given database.","minLength":1,"maxLength":63},"Databaseowner":{"type":"string","description":"The name of the role owning a given database.","minLength":1,"maxLength":63}}}}
```

## The Databasename object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"Databasename":{"type":"string","description":"The databasename of a given database.","minLength":1,"maxLength":63}}}}
```

## The Databaseowner object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"Databaseowner":{"type":"string","description":"The name of the role owning a given database.","minLength":1,"maxLength":63}}}}
```

## The Resource object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"Resource":{"type":"object","required":["type","id","href"],"properties":{"type":{"$ref":"#/components/schemas/ResourceType"},"id":{"$ref":"#/components/schemas/ResourceId"},"href":{"$ref":"#/components/schemas/ResourceHref"}}},"ResourceType":{"description":"The type of the resource.","type":"string","enum":["collection","cluster","backup","user","database"]},"ResourceId":{"type":"string","description":"The unique ID of the resource."},"ResourceHref":{"type":"string","description":"Absolute URL of the resource."}}}}
```

## The ResourceMetadata object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"ResourceMetadata":{"type":"object","properties":{"metadata":{"$ref":"#/components/schemas/Metadata"}}},"Metadata":{"type":"object","properties":{"createdBy":{"$ref":"#/components/schemas/UserIdentityURN"},"createdByUserId":{"$ref":"#/components/schemas/UserIdentityUUID"},"createdDate":{"$ref":"#/components/schemas/Timestamp"},"lastModifiedBy":{"$ref":"#/components/schemas/UserIdentityURN"},"lastModifiedByUserId":{"$ref":"#/components/schemas/UserIdentityUUID"},"lastModifiedDate":{"$ref":"#/components/schemas/Timestamp"},"resourceURN":{"$ref":"#/components/schemas/ResourceURN"}}},"UserIdentityURN":{"type":"string","description":"The URN of an IAM user."},"UserIdentityUUID":{"type":"string","format":"uuid","description":"The ID of an IAM user."},"Timestamp":{"type":"string","format":"date-time","description":"An ISO 8601 timestamp."},"ResourceURN":{"type":"string","description":"The URN of the resource."}}}}
```

## The Metadata object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"Metadata":{"type":"object","properties":{"createdBy":{"$ref":"#/components/schemas/UserIdentityURN"},"createdByUserId":{"$ref":"#/components/schemas/UserIdentityUUID"},"createdDate":{"$ref":"#/components/schemas/Timestamp"},"lastModifiedBy":{"$ref":"#/components/schemas/UserIdentityURN"},"lastModifiedByUserId":{"$ref":"#/components/schemas/UserIdentityUUID"},"lastModifiedDate":{"$ref":"#/components/schemas/Timestamp"},"resourceURN":{"$ref":"#/components/schemas/ResourceURN"}}},"UserIdentityURN":{"type":"string","description":"The URN of an IAM user."},"UserIdentityUUID":{"type":"string","format":"uuid","description":"The ID of an IAM user."},"Timestamp":{"type":"string","format":"date-time","description":"An ISO 8601 timestamp."},"ResourceURN":{"type":"string","description":"The URN of the resource."}}}}
```

## The UserIdentityURN object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"UserIdentityURN":{"type":"string","description":"The URN of an IAM user."}}}}
```

## The UserIdentityUUID object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"UserIdentityUUID":{"type":"string","format":"uuid","description":"The ID of an IAM user."}}}}
```

## The Timestamp object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"Timestamp":{"type":"string","format":"date-time","description":"An ISO 8601 timestamp."}}}}
```

## The ResourceURN object

```json
{"openapi":"3.0.3","info":{"title":"IONOS DBaaS PostgreSQL REST API","version":"1.0.0"},"components":{"schemas":{"ResourceURN":{"type":"string","description":"The URN of the resource."}}}}
```
